*----------------------------------------------------------
*  FUNCTION d2basex
*  base-10 to Base-x converter 
* SYNTAX: 
*   ? d2basex( ;
*            '17' ;  && your base-10 number
*            '0123456789ABCDEF' ; && your base-x system, in this case base-16 or hexidecimal
*            )
* RETURNS: base-x 'number'
* the geek responsible: Lee Rodgers, leebert@io.com, 
* Compu$erve: 73144,2276 or 73144.2276@compuserve.com
* Feedback appreciated.

*                   
* SEE BELOW: basex2d() which reverses the process
*----------------------------------------------------------
*FUNCTION d2basex
PARAMETERS n_dec, s_basex
n_base = LEN(s_basex)
s_ret = ''
DO WHILE n_dec>0
  s_ret=SUBSTR(s_basex,(n_dec%n_base)+1,1)+s_ret
  n_dec=INT(n_dec/n_base)
ENDDO

RETURN s_ret

*xxx-------------------------------------------------xxxx*
*8<----SNIP HERE FOR BASE-X TO DECIMAL ROUTINE>========
*xxx-------------------------------------------------xxxx*

*----------------------------------------------------------
*  =BASEX2D()
*  Base-x to base-10 converter 
* SYNTAX: 
*   ? basex2d( ;
*            '1F' ;  && your base-x 'number'
*            '0123456789ABCDEF' ; && your base-x system, in this case base-16 or hexidecimal
*            )
* RETURNS: base-10 number            
*                   
* the geek responsible: Lee Rodgers, leebert@io.com, 
* Compu$erve: 73144,2276 or 73144.2276@compuserve.com
* Feedback appreciated.

* Comments: unfortunately for Xbase, converting *BACK* to Decimal on very large
* numbers is a problem - the conversion *back* looses digits in *very* large 
* numbers and/or in *very* large base systems (e.g. base-256)

* however, this is a neat way to encrypt 6-char passwords, and whatnot. You can choose
* any base-x schema you wish, e.g. a scrambly base-36 scheme:
* '3YJ7P09IQSBK8XDUF1ZWGHR4TNV6LMCE2AO5' -- and get reliable encryption. 
* 
* I suppose you could write a message parser that parses
* a message in 6 or 8 byte blocks, scrambles it according to a public, then private key
* and use it as a poor man's PGP (no claims made as to it's encryption level <G>).
*
* ? basex2d('FOXPRO',"ABCDEFGHIJKLMNOPQRSTUVWXYZ ")
* ? d2basex( basex2d('FOXPRO',"SGMBHYICTVKZ ULEXNORJDPQAFW"),"SGMBHYICTVKZ ULEXNORJDPQAFW")
*----------------------------------------------------------
FUNCTION BASEX2D
PARAMETERS s_bx_num, s_basex
n_base = LEN(s_basex) && the length of your 'number' system is base-'x'

n_ret = 0
n_power = 0
n_posit = 1

DO WHILE n_posit <= LEN( s_bx_num )
  s_digi = SUBSTR( RIGHT( s_bx_num, n_posit ), 1, 1 )  && get base-x alpha-num value
  *  find out where it is in base-x definition,
  *  increase it by appropriate power/posit according to base-x
  n_ret = (AT(s_digi, s_basex )-1) * (n_base^n_power) + n_ret  
  * move along the string (an order of magnitude)
  n_posit = n_posit + 1  
  * and increase exponent by 1
  n_power = n_power + 1                                                       
ENDDO

RETURN n_ret